// Домашняя метеостанция
// Версия 1.0  Автор Волков Дмитрий dimavolk@mail.ru 2021

// Подключаем библиотеки
#include <Wire.h>                                       // Подключаем библиотеку Wire
#include <Adafruit_Sensor.h>                            // Подключаем библиотеку Adafruit_Sensor
#include <Adafruit_BME280.h>                            // Подключаем библиотеку Adafruit_BME280
#include <Adafruit_CCS811.h>                           //  Подключаем библиотеку Adafruit_CCS811 по умолчанию адрес датчика в библиотеке 0x5A

#define SEALEVELPRESSURE_HPA (1016.8)                  // Задаем давление в Гпа на высоте (вашего города над уровнем моря) для г.Котлас это 1016,8 ГПа
 
 Adafruit_BME280 bme;
 Adafruit_CCS811 ccs;

#include "SPI.h"                                       // Подключаем библиотеку SPI
#include <Adafruit_GFX.h>                              // Подключаем библиотеку работы с дисплеем
#include <ILI9488.h>                                  // Подключаем библиотеку дисплея на чипе ILI9488

#define TFT_CS         A0
#define TFT_DC         A1
#define TFT_LED        A2
#define TFT_RST        A3 

ILI9488 tft = ILI9488(TFT_CS, TFT_DC, TFT_RST);       // Инициализируем дисплей

word TEMP;  //Временная переменная
byte t[144]; //Суточный массив температуры
int  p[144]; // Суточный массив давления
byte v[144]; // Суточный масссив влажности
int  k[144]; // Суточный массив eCO2
byte i=0;   //Переменная циклов

void setup()
{
  Serial.begin(9600);
  pinMode(5, OUTPUT); // Вентилятор
  pinMode(6, OUTPUT); // Зуммер
  
  tft.begin(); digitalWrite(6, HIGH); delay(100); digitalWrite(6, LOW);
  
  if (!bme.begin(0x76)) {                                // Инициализация датчика BME280
     Serial.println("Could not find a valid BME280!");  // Печать сообщения об ошибке
     }
  if (!ccs.begin())
  {
    Serial.println("Failed to start sensor! Please check your wiring."); // Если при инициализации на старте датчик не найден,
                                                             // в мониторе порта вы получите уведомление об этом.                                                                      
  }
    //Калибровка сенсора температуры
  while (!ccs.available());
  float temp = ccs.calculateTemperature();
  ccs.setTempOffset(temp - 25.0);

  tft.fillScreen(ILI9488_BLACK); // Очистка экрана
  tft.drawRect(0, 0, 320, 480, ILI9488_WHITE);  // Рисуем рамку и клетки
  tft.drawLine(100, 0, 100, 480, ILI9488_WHITE);
  tft.drawLine(0, 119, 320, 119, ILI9488_WHITE);
  tft.drawLine(0, 239, 320, 239, ILI9488_WHITE);
  tft.drawLine(0, 359, 320, 359, ILI9488_WHITE);
// Блок температуры  
  tft.setCursor(13, 5); tft.setTextColor(ILI9488_WHITE);  tft.setTextSize(1); tft.print("Temperature:");
  tft.setCursor(30, 75); tft.setTextSize(2); tft.print("o"); tft.setCursor(45, 80); tft.setTextSize(3); tft.print("C");
//  tft.drawLine(101, 60, 320, 60, ILI9488_GREEN); // 18 град С
// Блок давления
  tft.setCursor(27, 125); tft.setTextColor(ILI9488_GREEN);  tft.setTextSize(1); tft.print("Pressure:");
  tft.setCursor(15, 195); tft.setTextSize(3); tft.print("mmHg");
//  tft.drawLine(101, 180, 320, 180, ILI9488_GREEN); // 750 мм.рт.ст. 
// Блок влажности 
  tft.setCursor(27, 245); tft.setTextColor(ILI9488_RED);  tft.setTextSize(1); tft.print("Humidity:");
  tft.setCursor(45, 315); tft.setTextSize(3); tft.print("%");
//  tft.drawLine(101, 300, 320, 300, ILI9488_GREEN); // 50%
// Блок CO2
  tft.setCursor(40, 365); tft.setTextColor(ILI9488_BLUE);  tft.setTextSize(1); tft.print("eCO2:");
  tft.setCursor(25, 435); tft.setTextSize(3); tft.print("ppm"); 
// Обнуление массивов
for(i=0;i<144;i++){
  t[i]=1; p[i]=701; v[i]=10; k[i]=401;
}
i=0;     
}
void loop()
{
  
 //+
 
 // Температура
  tft.fillRect(1, 34, 98, 32, ILI9488_BLACK); 
  tft.setCursor(25, 35); 
  tft.setTextColor(ILI9488_WHITE);  tft.setTextSize(4);
  
//  Serial.print("Температура = ");                       // Печать текста
//  Serial.print(round(bme.readTemperature()));           // Печать температуры
    TEMP = round(bme.readTemperature());  
    tft.print(TEMP); t[143]=TEMP;
//  Serial.print("*C");                                 // Печать текста
//  Serial.print();

//Вывод графика температуры
   tft.fillRect(101, 1, 144, 118, ILI9488_BLACK);  tft.drawLine(101, 60, 320, 60, ILI9488_GREEN);
   tft.setCursor(300, 65); tft.setTextColor(ILI9488_GREEN);  tft.setTextSize(1); tft.print("18");
   tft.fillRect(270, 20, 49, 22, ILI9488_BLACK); tft.setCursor(270, 20); tft.setTextColor(ILI9488_WHITE);  tft.setTextSize(3); tft.print(t[142]);
   tft.fillRect(270, 80, 49, 22, ILI9488_BLACK); tft.setCursor(270, 80); tft.setTextColor(ILI9488_WHITE);  tft.setTextSize(3); tft.print(t[0]);
   
   for(i=0; i<144; i++){
       tft.drawPixel(101+i, 120-t[i]*3.3, ILI9488_WHITE); 
}

// Давление  
  tft.fillRect(1, 154, 98, 32, ILI9488_BLACK); 
  tft.setCursor(15, 155);
  tft.setTextColor(ILI9488_GREEN);  tft.setTextSize(4);
 
//  Serial.print("Давление = ");                          // Печать текста       
//  Serial.print(round(bme.readPressure() * 0.0075));    // Печать атмосферное давление
//  Serial.println("мм.рт.ст.");                        // Печать текста
    TEMP = round(bme.readPressure() * 0.0075);  
    tft.print(TEMP); p[143]=TEMP;
//  Serial.println();

//Вывод графика давления 
 tft.setCursor(295, 185); tft.setTextColor(ILI9488_GREEN);  tft.setTextSize(1); tft.print("750");
 tft.fillRect(101, 121, 144, 118, ILI9488_BLACK); tft.drawLine(101, 180, 320, 180, ILI9488_GREEN);
 tft.fillRect(250, 140, 69, 22, ILI9488_BLACK); tft.setCursor(250, 140); tft.setTextColor(ILI9488_GREEN);  tft.setTextSize(3); tft.print(p[142]);
 tft.fillRect(250, 200, 69, 22, ILI9488_BLACK); tft.setCursor(250, 200); tft.setTextColor(ILI9488_GREEN);  tft.setTextSize(3); tft.print(p[0]);
 
 for(i=0; i<144; i++){
       tft.drawPixel(101+i, 180-((p[i]-700)*1.2+120)+180, ILI9488_GREEN); }
  
// Влажность  
  tft.fillRect(1, 274, 98, 32, ILI9488_BLACK); 
  tft.setCursor(25, 275);
  tft.setTextColor(ILI9488_RED);  tft.setTextSize(4);
//  Serial.print("Влажность = ");                            // Печать текста
//  Serial.print(round(bme.readHumidity()));               // Печать влажности
//  Serial.println("%");                                  // Печать текста
    TEMP = round(bme.readHumidity());  
    tft.print(TEMP); v[143]=TEMP; 
//  Serial.println();                                       // Новая строка

  // Вывод графика влажности 
 tft.setCursor(300, 305); tft.setTextColor(ILI9488_GREEN);  tft.setTextSize(1); tft.print("50");
 tft.fillRect(101, 241, 144, 118, ILI9488_BLACK); tft.drawLine(101, 300, 320, 300, ILI9488_GREEN);
 tft.fillRect(270, 260, 49, 22, ILI9488_BLACK); tft.setCursor(270, 260); tft.setTextColor(ILI9488_RED);  tft.setTextSize(3); tft.print(v[142]);
 tft.fillRect(270, 320, 49, 22, ILI9488_BLACK); tft.setCursor(270, 320); tft.setTextColor(ILI9488_RED);  tft.setTextSize(3); tft.print(v[0]);
 
 for(i=0; i<144; i++){
       tft.drawPixel(101+i, 300-(v[i]*1.2+240)+300, ILI9488_RED); }

// eCO2       
  if (ccs.available())
  {
   float temp = ccs.calculateTemperature();
    if (ccs.readData())
    {
      tft.fillRect(1, 394, 98, 32, ILI9488_BLACK); 
      tft.setTextColor(ILI9488_BLUE);  tft.setTextSize(4);
//      Serial.print("eCO2: ");   // Значение уровня eCO2
//      Serial.print(ccs.geteCO2());
   TEMP=0;
   for (i=0; i<10; i++) { 
    TEMP = TEMP + ccs.geteCO2(); delay(100); }  
    TEMP=TEMP/10;
   if(TEMP < 999) {  
     tft.setCursor(20, 395);}
      else  {tft.setCursor(3, 395);}
   
    if (TEMP>1500 && TEMP<2000) {  tft.fillRect(1, 394, 98, 32, ILI9488_RED);  tft.print(TEMP); k[143]=TEMP; digitalWrite(6, HIGH); delay(100); digitalWrite(6, LOW); }
       if (TEMP>2000) {  tft.fillRect(1, 394, 98, 32, ILI9488_RED);  tft.print(TEMP); k[143]=TEMP; digitalWrite(6, HIGH); delay(10000); digitalWrite(6, LOW); } 
           else {tft.print(TEMP); k[143]=TEMP;}
//      Serial.println();
    }
    else
    {
      Serial.println("ERROR!");
     // while (100);
    }
  }
// Вывод графика eCO2 
 tft.fillRect(101, 361, 145, 118, ILI9488_BLACK); tft.drawLine(101, 443, 320, 443, ILI9488_RED);
 tft.setCursor(290, 448); tft.setTextColor(ILI9488_RED);  tft.setTextSize(1); tft.print("1500");
 tft.fillRect(250, 380, 69, 22, ILI9488_BLACK); tft.setCursor(250, 380); tft.setTextColor(ILI9488_BLUE);  tft.setTextSize(2); tft.print(k[142]);
 
 for(i=0; i<144; i++){
//       tft.drawPixel(101+i, 420-(k[i]*0.025+360)+420, ILI9488_BLUE); 
      if (k[i]<1499) {tft.drawCircle(101+i, 420-(k[i]*0.025+360)+420, 1, ILI9488_BLUE);}
       else {tft.drawCircle(101+i, 420-(k[i]*0.025+360)+420, 1, ILI9488_RED);} }
  
  for (i=0; i<143; i++) {
  t[i]=t[i+1];  p[i]=p[i+1]; v[i]=v[i+1]; k[i]=k[i+1]; } 
  
  delay(60000); delay(60000); delay(60000); delay(60000); delay(60000); delay(60000); delay(60000); delay(60000); 
  digitalWrite(5, HIGH); delay(60000); digitalWrite(5, LOW); delay(60000);
  
}
